//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadPdfToJpegDll()
{
	m_hinstLib = LoadLibrary("pdftojpeg.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pLoad = (MLoad *)GetProcAddress(m_hinstLib, "MLoad");
	if( pLoad == NULL ){ 
		FreePdfToJpegDll(); 
		return FALSE;
	}
	pEncode = (MEncode *)GetProcAddress(m_hinstLib, "MEncode");
	if( pEncode == NULL ){
		FreePdfToJpegDll();
		return FALSE;
	}
	pFree = (MFree *)GetProcAddress(m_hinstLib, "MFree");
	if( pFree == NULL ){
		FreePdfToJpegDll();
		return FALSE;
	}
	pGetCount = (MGetCount *)GetProcAddress(m_hinstLib, "MGetCount");
	if( pGetCount == NULL ){
		FreePdfToJpegDll();
		return FALSE;
	}
	pSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pSetParam == NULL ){ 
		FreePdfToJpegDll(); 
		return FALSE;
	}

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL TForm1::FreePdfToJpegDll()
{
    if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadPdfToJpegDll() == FALSE ){
        ShowMessage("Load pdftojpeg.dll failed!");
		return;
	}

	long id = pLoad("test.pdf",NULL);
	if(id==-1){
        ShowMessage("PDF file unexist or damaged!");
		FreePdfToJpegDll();
		return;
	}
	if(id==-2){
        ShowMessage("PDF file is restricted!");
		FreePdfToJpegDll();
		return;
	}

	pSetParam(id,"",IMAGE_FORMAT_JPG,24,75,0,0,0,0,96,96);

	long pageCount = pGetCount(id);
	for(long i=1; i<=pageCount; i++){
		pEncode(id,i);
		ProgressBar1->Position = i*100/pageCount;
	}
	pFree(id);

	FreePdfToJpegDll();
    ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadPdfToJpegDll() == FALSE ){
        ShowMessage("Load pdftojpeg.dll failed");
		return;
	}

	long id = pLoad("test.pdf",NULL);	
	if(id==-1){
        ShowMessage("PDF file unexist or damaged!");
		FreePdfToJpegDll();
		return;
	}
	if(id==-2){
        ShowMessage("PDF file is restricted!");
		FreePdfToJpegDll();
		return;
	}

	pSetParam(id,"",IMAGE_FORMAT_JP2,24,75,0,90,800,600,120,120);

	long pageCount = pGetCount(id);
	for(long i=1; i<=pageCount; i++){
		pEncode(id,i);
		ProgressBar1->Position = i*100/pageCount;
	}
	pFree(id);

	FreePdfToJpegDll();
    ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
